#ifndef TRIE_H_
#define TRIE_H_

struct trie;

struct trie * trie_new();
void trie_delete(struct trie * trie);

size_t trie_size(struct trie * trie);
size_t trie_count(struct trie * trie);

char * trie_insert(struct trie * trie, char * key, void * data);
void * trie_find(struct trie * trie, char * key);
void * trie_remove(struct trie * trie, char * key);

void trie_walk_keys(struct trie * trie, void (*op)(char * k, void * d) );

void trie_dump(struct trie * trie);
void trie_dump_raw(struct trie * trie);

struct list * trie_get_subkeys(struct trie * trie, char * prefix, size_t limit);
void          trie_free_subkey_list(struct list * list);


#endif
